<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfConfigEasyPay ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfConfigEasyPay
 * @subpackage Arrays
 */
class ArrayOfConfigEasyPay extends AbstractStructArrayBase
{
    /**
     * The ConfigEasyPay
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ConfigEasyPay[]
     */
    public $ConfigEasyPay;
    /**
     * Constructor method for ArrayOfConfigEasyPay
     * @uses ArrayOfConfigEasyPay::setConfigEasyPay()
     * @param \StructType\ConfigEasyPay[] $configEasyPay
     */
    public function __construct(array $configEasyPay = array())
    {
        $this
            ->setConfigEasyPay($configEasyPay);
    }
    /**
     * Get ConfigEasyPay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ConfigEasyPay[]|null
     */
    public function getConfigEasyPay()
    {
        return isset($this->ConfigEasyPay) ? $this->ConfigEasyPay : null;
    }
    /**
     * Set ConfigEasyPay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ConfigEasyPay[] $configEasyPay
     * @return \ArrayType\ArrayOfConfigEasyPay
     */
    public function setConfigEasyPay(array $configEasyPay = array())
    {
        foreach ($configEasyPay as $arrayOfConfigEasyPayConfigEasyPayItem) {
            // validation for constraint: itemType
            if (!$arrayOfConfigEasyPayConfigEasyPayItem instanceof \StructType\ConfigEasyPay) {
                throw new \InvalidArgumentException(sprintf('The ConfigEasyPay property can only contain items of \StructType\ConfigEasyPay, "%s" given', is_object($arrayOfConfigEasyPayConfigEasyPayItem) ? get_class($arrayOfConfigEasyPayConfigEasyPayItem) : gettype($arrayOfConfigEasyPayConfigEasyPayItem)), __LINE__);
            }
        }
        if (is_null($configEasyPay) || (is_array($configEasyPay) && empty($configEasyPay))) {
            unset($this->ConfigEasyPay);
        } else {
            $this->ConfigEasyPay = $configEasyPay;
        }
        return $this;
    }
    /**
     * Add item to ConfigEasyPay value
     * @throws \InvalidArgumentException
     * @param \StructType\ConfigEasyPay $item
     * @return \ArrayType\ArrayOfConfigEasyPay
     */
    public function addToConfigEasyPay(\StructType\ConfigEasyPay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ConfigEasyPay) {
            throw new \InvalidArgumentException(sprintf('The ConfigEasyPay property can only contain items of \StructType\ConfigEasyPay, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ConfigEasyPay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ConfigEasyPay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ConfigEasyPay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ConfigEasyPay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ConfigEasyPay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ConfigEasyPay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ConfigEasyPay
     */
    public function getAttributeName()
    {
        return 'ConfigEasyPay';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfConfigEasyPay
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
